> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create a Machine/Instance Type association

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/instance/type/{instanceTypeId}/machine
Content-Type: application/json

Associate a Machine to an Instance Type

Org must have an Infrastructure Provider entity that owns the Instance Type and the Machine. User must have `FORGE_PROVIDER_ADMIN` authorization role.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/instance-type/create-instance-type-machine-association

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/instance/type/{instanceTypeId}/machine:
    post:
      operationId: create-instance-type-machine-association
      summary: Create a Machine/Instance Type association
      description: >-
        Associate a Machine to an Instance Type


        Org must have an Infrastructure Provider entity that owns the Instance
        Type and the Machine. User must have `FORGE_PROVIDER_ADMIN`
        authorization role.
      tags:
        - subpackage_instanceType
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: instanceTypeId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/MachineInstanceType'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MachineInstanceTypeCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    MachineInstanceTypeCreateRequest:
      type: object
      properties:
        machineIds:
          type: array
          items:
            type: string
            format: uuid
      required:
        - machineIds
      description: Associates one or more Machines with an Instance Type
      title: MachineInstanceTypeCreateRequest
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    MachineInstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: >-
            Deprecated: Use `machineId` when identifying a Machine/Instance Type
            association. This field will be removed on July 9th, 2026 0:00 UTC.
        machineId:
          type: string
        instanceTypeId:
          type: string
          format: uuid
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Associates a machine with an Instance Type
      title: MachineInstanceType
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine"

payload = { "machineIds": ["497f6eca-6276-4993-bfeb-53cbbbba6f08", "59c8d465-69f1-447f-80f8-1bc85627a03b", "0a44ffc3-39ba-46c6-b483-be00a1e2cc27"] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"machineIds":["497f6eca-6276-4993-bfeb-53cbbbba6f08","59c8d465-69f1-447f-80f8-1bc85627a03b","0a44ffc3-39ba-46c6-b483-be00a1e2cc27"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine"

	payload := strings.NewReader("{\n  \"machineIds\": [\n    \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n    \"59c8d465-69f1-447f-80f8-1bc85627a03b\",\n    \"0a44ffc3-39ba-46c6-b483-be00a1e2cc27\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"machineIds\": [\n    \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n    \"59c8d465-69f1-447f-80f8-1bc85627a03b\",\n    \"0a44ffc3-39ba-46c6-b483-be00a1e2cc27\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"machineIds\": [\n    \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n    \"59c8d465-69f1-447f-80f8-1bc85627a03b\",\n    \"0a44ffc3-39ba-46c6-b483-be00a1e2cc27\"\n  ]\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine', [
  'body' => '{
  "machineIds": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "59c8d465-69f1-447f-80f8-1bc85627a03b",
    "0a44ffc3-39ba-46c6-b483-be00a1e2cc27"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"machineIds\": [\n    \"497f6eca-6276-4993-bfeb-53cbbbba6f08\",\n    \"59c8d465-69f1-447f-80f8-1bc85627a03b\",\n    \"0a44ffc3-39ba-46c6-b483-be00a1e2cc27\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["machineIds": ["497f6eca-6276-4993-bfeb-53cbbbba6f08", "59c8d465-69f1-447f-80f8-1bc85627a03b", "0a44ffc3-39ba-46c6-b483-be00a1e2cc27"]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId/machine")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```